ghc-8.2.2: The GHC API

Safe Haskell | None
Language | Haskell2010

Pair

# Documentation

data Pair a #

Constructors

Pair |

Fields

- pFst :: a
- pSnd :: a

Instances

Functor Pair # |
Methods fmap :: (a -> b) -> Pair a -> Pair b Source # (<$) :: a -> Pair b -> Pair a Source #
Applicative Pair # |
Methods pure :: a -> Pair a Source # (<*>) :: Pair (a -> b) -> Pair a -> Pair b Source # liftA2 :: (a -> b -> c) -> Pair a -> Pair b -> Pair c Source # (*>) :: Pair a -> Pair b -> Pair b Source # (<*) :: Pair a -> Pair b -> Pair a Source #
Foldable Pair # |

Methods

fold :: Monoid m => Pair m -> m Source #

foldMap :: Monoid m => (a -> m) -> Pair a -> m Source #

foldr :: (a -> b -> b) -> b -> Pair a -> b Source #

foldr' :: (a -> b -> b) -> b -> Pair a -> b Source #

foldl :: (b -> a -> b) -> b -> Pair a -> b Source #

foldl' :: (b -> a -> b) -> b -> Pair a -> b Source #

foldr1 :: (a -> a -> a) -> Pair a -> a Source #

foldl1 :: (a -> a -> a) -> Pair a -> a Source #

toList :: Pair a -> [a] Source #

null :: Pair a -> Bool Source #

length :: Pair a -> Int Source #

elem :: Eq a => a -> Pair a -> Bool Source #

maximum :: Ord a => Pair a -> a Source #

minimum :: Ord a => Pair a -> a Source #

sum :: Num a => Pair a -> a Source #

product :: Num a => Pair a -> a Source #

Traversable Pair # |
Methods traverse :: Applicative f => (a -> f b) -> Pair a -> f (Pair b) Source # sequenceA :: Applicative f => Pair (f a) -> f (Pair a) Source # mapM :: Monad m => (a -> m b) -> Pair a -> m (Pair b) Source # sequence :: Monad m => Pair (m a) -> m (Pair a) Source #
Monoid a => Monoid (Pair a) # |
Methods mempty :: Pair a Source # mappend :: Pair a -> Pair a -> Pair a Source # mconcat :: [Pair a] -> Pair a Source #
Outputable a => Outputable (Pair a) # |
Methods ppr :: Pair a -> SDoc # pprPrec :: Rational -> Pair a -> SDoc #

unPair :: Pair a -> (a, a) #

toPair :: (a, a) -> Pair a #

swap :: Pair a -> Pair a #

pLiftFst :: (a -> a) -> Pair a -> Pair a #

pLiftSnd :: (a -> a) -> Pair a -> Pair a #